#!/bin/bash
source /etc/conf.d/vdr.admin.cfg

if [ "$(pidof vdr)" != "" ] ; then
   /etc/init.d/vdr stop
   RESTART=1
else
   RESTART=0
fi

/_config/bin/dvbmod check
/_config/bin/dvbmod load
echo "Waiting for dvb devices to register ..."
sleep 15

DVB_CARDS=$(ls -l /dev/dvb | grep adapter | wc -l 2>/dev/null)

PRIM_DVB=$(ls -l /dev/dvb/*/osd* | wc -l 2>/dev/null)

sh /_config/bin/detect_dxr3.sh

EM84=$(sh /_config/bin/detect_modules.sh 2>/dev/null| grep "realmagic84xx")
if [ "$EM84" != "" ] ; then
   logger -s "EM84 detected - adding em84xx plugin"
   $SETVAL "PLG_em84xx" "1"
   $SETVAL "PLG_xine" "0"
   $SETVAL "PLG_dvd" "0"
   $SETVAL GUI_SWITCH_OUTPUT 1
   $SETVAL GUI_LOOP_OUTPUT 0
elif [ "$DXR3" = "1" ] ; then
   logger -s "DXR3 deetcted - adding dxr3 plugin"
   $SETVAL "PLG_dxr" "1"
   $SETVAL "PLG_xine" "0"
   $SETVAL "PLG_dvd" "4"
   $SETVAL "GUI" "FreeVo"
elif [ "$PRIM_DVB" = "0" ] ; then    
   logger -s "No primary DVB card found - adding xine plugin"
   $SETVAL "PLG_xine" "1"
   $SETVAL "GUI" "FreeVo"
fi

$SETVAL "DVB_CARD_NUM" $DVB_CARDS
if [ "$RESTART" = "1" ] ; then
   /etc/init.d/vdr start
fi
