#!/bin/bash
source /etc/conf.d/vdr
SVDRPCMD="/usr/bin/svdrpsend.pl"
EPG_STAT_FILE="/video/~epgscan"

if [ "$1" != "-f" ] ; then
   FDAY=$(ls -l --time-style=+%d $EPG_STAT_FILE | tr -s ' ' |cut -f6 -d ' ')
   ACT_DAY=$(date +%d)
   if [ "$FDAY" = "$ACT_DAY" ] ; then
      logger -s "Heute wurde schon epg-gescanned"
      exit
   fi
fi

# Get epgdata via epgscan or tvm2vdr
if [ "$EPGSCAN" = "TVMovie" ] ; then
   [ "$VDRADMIN" = "1" ] && /etc/init.d/vdradmind stop
   [ "$XXV" = "1" ] && /etc/init.d/xxvd stop
   cd /etc/vdr/tvmovie2vdr
   logger -s "Starting tvmovie2vdr"
   $SVDRPCMD MESG "Suche EPG per TVMovie ..."
   /etc/init.d/ntp-client stop > /dev/null 2>&1
   /etc/init.d/ntp-client start > /dev/null 2>&1

   mkdir /video/epgimages > /dev/null 2>&1
   cd /etc/vdr/tvmovie2vdr
   # start tvmovie2vdr
   ./tvm2vdr.pl >> /var/log/tvm2vdr.log

   $SVDRPCMD MESG "EPG-Suche beendet"
   logger -s "EPG Suche beendet"
   # clear old timer for vdr < 1.3.23
   ./clearoldtimer.pl

   # cleanup old images
   find /video/epgimages/ -type f  -mtime +10 -exec rm {} \;

   [ "$VDRADMIN" = "1" ] && /etc/init.d/vdradmind start
   [ "$XXV" = "1" ] && /etc/init.d/xxvd start
elif [ "$EPGSCAN" = "EPGScan" ] ; then
   $SVDRPCMD MESG "Starte EPG-Scan ..."
   $SVDRPCMD SCAN
fi
touch $EPG_STAT_FILE
						       
