#!/bin/bash
#
source /etc/conf.d/vdr.admin.cfg
BACKUP_DIR="/mnt/hda5/g2v-backup"
OLD_CONFIG_FILE="$BACKUP_DIR/etc/conf.d/vdr"

checkvar() {
   case "$1" in
      LIRC)
         if [ "$2" = "Other" ] && [ -f $BACKUP_DIR/etc/lircd.conf ] ; then
            cp -vf $BACKUP_DIR/etc/lircd.conf /etc/
            cp -vf /_config/install/lircd.conf.$2 /_config/install/lircd.conf.$2.org
            cp -vf $BACKUP_DIR/_config/install/lircd.conf.$2 /_config/install/
            $SETVAL LIRC "$2"
         fi
         if [ -f $BACKUP_DIR/etc/vdr/remote.conf ] && [ "$(/_config/bin/query_mb.sh)" != "ACTIVY" ] ; then
            cp -vf /_config/install/vdr/remote.conf /_config/install/vdr/remote.conf.org
            cat $BACKUP_DIR/etc/vdr/remote.conf |sed -e "/\.Jump...Slow/d"  -e "s/\.JumpRew/\.Prev/g"  -e "s/\.JumpFwd/\.Next/g" >  /_config/install/vdr/remote.conf
            cp -vf /_config/install/vdr/remote.conf /etc/vdr/remote.conf
         fi
         ;;
      RCV)
         if [ -f $BACKUP_DIR/etc/vdr/channels.conf ] ; then
            OLD_CC=$(sed -e "/^:.*/d" $BACKUP_DIR/etc/vdr/channels.conf | head -n 1 |  sed -e "s/[^:]//g" | wc -c)
            NEW_CC=$(sed -e "/^:.*/d" /etc/vdr/channels.conf.sat | head -n 1 |  sed -e "s/[^:]//g" | wc -c)
            if [ "$OLD_CC" = "$NEW_CC" ] ; then
               if [ "$2" = "SAT" ] ; then
                  RCV="sat"
               elif [ "$2" = "Kabel" ] ; then
                  RCV="cable"
               else
                  RCV="terr"
               fi
               cp -vf /_config/install/vdr/channels.conf.$RCV /_config/install/vdr/channels.conf.$RCV.org
               cp -vf $BACKUP_DIR/etc/vdr/channels.conf /_config/install/vdr/channels.conf.$RCV
               cp -vf $BACKUP_DIR/etc/vdr/channels.conf /etc/vdr/channels.conf
            else 
               echo "Format der channels.conf unterschiedlich"
            fi
         fi
         ;;
#      PLUGINS)
#         if [ -f $BACKUP_DIR/etc/vdr/plugins/admin/admin.conf ] ; then
#            perl /etc/vdr/plugins/admin/cfgplg.pl $2
#         fi
#         ;;
      IPADR|DHCP|NAMESERVER|NET|HOSTNAME|GATEWAY)
         $SETVAL $1 "$2"
         ;;
         
      *)
         ;;
   esac
}


if [ -f $OLD_CONFIG_FILE ] ; then
   echo "Alte Konfiguration wird migriert ..."
   OLDVARS=$(grep -v "^#" $OLD_CONFIG_FILE | grep "=" | cut -f 1 -d "=")

   for i in $OLDVARS ; do
      VAL=$(grep "^${i}=" $OLD_CONFIG_FILE | cut -f 2 -d '"')
#      $SETVAL $i "$VAL"
      checkvar $i "$VAL"
   done
else   
   echo "Nichts zum migrieren gefunden"
fi
