#! /bin/bash
#
MOUNT_POINT="/media"

mount_all() {
   if [ ! -e $MOUNT_POINT ] ; then
      mkdir -p $MOUNT_POINT
   fi
   for i in $(seq 1 9) ; do
      USB_DEV=$(ls /dev/sd?? /dev/sg?? 2>/dev/null)
      if [ "$USB_DEV" = "" ] ; then
         sleep 1
      else
         break
      fi	 
   done      
#   USB_MOUNTS=$(mount | grep "^/dev" | grep "on ${MOUNT_POINT}/usbdisk" | cut -f 3 -d " ")
#   logger -s "USB: <${USB_DEV}-${USB_MOUNTS}>"
   for i in $USB_DEV ; do
      MOUNTED=$(mount | grep "^${i}")
      if [ "$MOUNTED" = "" ] ; then
         for j in $(seq 1 9) ; do
            if [ ! -e ${MOUNT_POINT}/usbdisk${j} ] ; then
               mkdir ${MOUNT_POINT}/usbdisk${j} > /dev/null 2>&1
               mount $i ${MOUNT_POINT}/usbdisk${j}
               if [ "$?" = "0" ] ; then
                  logger -s "$i mounted on ${MOUNT_POINT}/usbdisk${j}"
               else
                  rmdir ${MOUNT_POINT}/usbdisk${j} > /dev/null 2>&1
                  logger -s "Error $? <mount $i ${MOUNT_POINT}/usbdisk${j}>"
               fi   
               break
            fi   
         done
      else
         logger -s "$i is already mounted"
      fi
   done
}

unmount_all() {
   USB_MOUNTS=$(mount | grep "^/dev" | grep "on ${MOUNT_POINT}/usbdisk" | cut -f 3 -d " ")
#   echo "<$USB_MOUNTS>"
   for i in $USB_MOUNTS ; do
      umount ${i} > /dev/null 2>&1
      logger -s "${i} unmounted"
      rmdir ${i} > /dev/null 2>&1
   done
   rmdir $MOUNT_POINT/usbdisk* > /dev/null 2>&1
}

#set -x

if [ "$1" = "-mount" ] ; then
   unmount_all
   [ "$2" = "-wait" ] && sleep 20
   mount_all
   echo "/_config/bin/linkvid.sh /media _MEDIA_" | at now
elif [ "$1" = "-unmount" ] ; then
   unmount_all
   echo "/_config/bin/linkvid.sh /media _MEDIA_" | at now
elif [ "$1" = "-remount" ] ; then
   unmount_all
   rmmod usb-storage
   modprobe usb-storage
   echo "$0 -mount"  
   echo "$0 -mount" | at +1 minute
else
   logger -s "usbmount unknown parameter <$1>"
   echo "Syntax: $0 [-mount|-unmount|-remount]"
fi

