#!/bin/bash
#
MODULES="lirc_serial lirc_atiusb"
source /etc/conf.d/vdr
source /etc/conf.d/vdr.admin.cfg

/etc/init.d/lircd stop
/etc/init.d/irexec stop
for i in $MODULES ; do
   modprobe -r $i
done
$SETVAL PLG_lircrc 0

if [ "$LIRC" = "Tastatur" ] ; then
   logger -s "ADMIN - Tastaturmodus"
   rc-update del lircd  >/dev/null 2>&1
   rc-update del irexec  >/dev/null 2>&1
   CONTROL_MODE=1
elif [ "$LIRC" = "Nexus" ]; then
   logger -s "ADMIN - LIRC: Nexus"
   rc-update del lircd  >/dev/null 2>&1
   rc-update del irexec  >/dev/null 2>&1
   $SETVAL PLG_remote 1
   CONTROL_MODE=1
else
   logger -s "ADMIN - LIRC: $LIRC"
   if [ -f /_config/install/lircd.conf.$LIRC ] ; then
      cp -f /_config/install/lircd.conf.$LIRC /etc/lircd.conf  >/dev/null 2>&1
   else
      if [ "$LIRC" != "Other" -a "$LIRC" != "ActivyFB" ]  ; then
         echo "Unknown LIRC parameter $1"
         exit 1
      fi
   fi
   CONTROL_MODE=0
   rc-update add lircd boot >/dev/null 2>&1
   rc-update add irexec default >/dev/null 2>&1
   sed -i /etc/conf.d/lircd -e "/LIRCD_USESERIAL/d" -e "/LIRCD_USEATIUSBMODULE/d" -e "/LIRCD_USEACTIVY/d"
   LSER=1
   LATI=0
   LACT=0
   if [ "$LIRC" = "MedionX10" ] ; then
      if [ "$(grep "options lirc_atiusb" /etc/modules.d/lircd)" = "" ] ; then 
         echo "options lirc_atiusb debug=0 mask=0xFFFF repeat=25 emit_updown=1 emit_modekeys=2" >> /etc/modules.d/lircd
         modules-update
      fi
      LSER=0
      LATI=1
   elif [ "$LIRC" = "ActivyFB" ] ; then
      LSER=0
      LACT=1
   fi
   echo "LIRCD_USESERIAL=$LSER" >> /etc/conf.d/lircd
   echo "LIRCD_USEATIUSBMODULE=$LATI" >> /etc/conf.d/lircd
   echo "LIRCD_USEACTIVY=$LACT" >> /etc/conf.d/lircd
   /etc/init.d/lircd start
   /etc/init.d/irexec start
fi
sed -i $CONFIG/setup.conf -e "s/^mplayer\.ControlMode.*/mplayer\.ControlMode = ${CONTROL_MODE}/"
echo 'Done!'
exit 0

